#!/usr/bin/perl -w
#
# Use generated "site name".xml file to build a mozilla-style sidebar tab.
# If enabled, scale topic images to fit and cache locally to ease server load.
#

use strict;
use XML::Parser;
#use Slash::Constants ':slashd';

# Image::Magick is required if you're going to resize images
use Image::Magick;

use vars qw( %task $me $GL_INSTORY $GL_GOTSTORY $GL_STD $GL_RSZ $topicurl $imgbase $imgsrcdir $imgdstdir $my_opt %stvars );

$task{$me}{timespec} = '15,45 * * * *';
$task{$me}{on_startup} = 1;
#$task{$me}{fork} = SLASHD_NOWAIT;
$task{$me}{code} = sub {
    my($virtual_user, $constants, $slashdb, $user, $info) = @_;
    my $basedir = $constants->{basedir};

    # Resize images? [0|1]
    $GL_RSZ = 1;
    my $p = new XML::Parser(Handlers => {Start => \&_handle_start,
					 End   => \&_handle_end,
					 Char  => \&_handle_char
					 }
			    );
    my $sitename = $constants->{sitename};
    $sitename =~ tr/[A-Z]/[a-z]/;  # could use lc instead, but who cares?
    $sitename =~ s/\W+//g;
    my $xmlfile = $basedir."/".$sitename.".xml";
    my $output = $basedir."/mozbar.html";
    $imgsrcdir = $basedir."/images/topics/";
    $imgdstdir = $basedir."/images/mozbar/";
    $imgbase = $constants->{rootdir}."/images/mozbar/";
    $topicurl = $constants->{rootdir}."/search.pl";
    my $refresh_url = $constants->{rootdir}."/mozbar.html";
    $p->parsefile($xmlfile);
    if ($GL_GOTSTORY){
	open (SBAR, ">$output") or die "Cannot open $output for writing: $!\n";
	print SBAR qq%
<html>
<head>
<meta http-equiv=\"refresh\" content=\"1800; url=$refresh_url\">
<style>
    .link { font-family: \"Sans-Serif\", \"Arial\", \"Helvetica\";
            font-size: 8pt;
	    color: blue;
	    text-decoration: none;}
    .misc { font-family: \"Sans-Serif\", \"Arial\", \"Helvetica\";
            font-size: 8pt;
  	    color: grey;
	    text-decoration: none;}

</style>
</head>
<body>
<table border=0 cellpadding=0 cellspacing=0 width=\"100\%\">
$my_opt
</table>
</body>
</html>
%;
    }
};

sub _handle_start{
    my ($p, $data) = @_;
    if ($data eq "story"){
	$GL_INSTORY = 1;
	$GL_GOTSTORY = 1;
    }
    else{
	$GL_STD = $data;
    }
}

sub _handle_end{
    my ($p, $data) = @_;
    my ($imgsrc, $imgdst, $img);
    if ($data eq "story"){
	$stvars{time} = join(":",(split(/\:/,(split(/\ /,$stvars{time}))[1]))[0,1]);
	$my_opt .= "<tr><td><a href=\"".$topicurl."?topic=$stvars{topic}\" target=\"_content\"><img src=\"$imgbase$stvars{image}\" alt=\"$stvars{section}\" border=0></a></td>\n";
	$my_opt .= "<td valign=\"top\"><a href=\"$stvars{url}\" class=\"link\" target=\"_content\">$stvars{title}</a></td>\n";
	$my_opt .= "<td><img src=\"".$imgbase."spacer.gif\" height=1 width=5></td><td valign=\"top\"><table border=0 cellpadding=0 cellspacing=0><tr><td class=\"misc\">$stvars{time}</td></tr>\n";
	$my_opt .= "<tr><td bgcolor=\"#cccccc\"><img src=\"".$imgbase."spacer.gif\" width=2 height=1></td></tr><tr><td class=\"misc\" align=\"right\">$stvars{comments}</td></tr></table></td></tr>\n";
	$my_opt .= "<tr><td colspan=4 background=\"".$imgbase."bar.gif\"><img src=\"".$imgbase."spacer.gif\" height=5 width=10></td></tr>\n";
	
	# Resize image, if needed
	if ($GL_RSZ){
	    $imgsrc = $imgsrcdir . $stvars{image};
	    $imgdst = $imgdstdir . $stvars{image};
	    $img = Image::Magick->new;
	    $img->read($imgsrc);
	    $img->Set(type=>'TrueColorMatte');
	    $img->Resize(geometry=>'30x30', blur=>0);
	    $img->Write($imgdst);
	}
	undef %stvars;
    }
    else{
	$GL_STD = "";
    }
}

sub _handle_char{
    my ($p, $data) = @_;
    if ($GL_STD){
	$stvars{$GL_STD} = $data;
    }
}

1;

